#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>

namespace Ui {
class MainWindow;
}

class Simulation;

class MainWindow : public QMainWindow
{
    Q_OBJECT
    
public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    
private:
    Ui::MainWindow *ui;
    QTimer *m_simuTimer;
    Simulation* p_simu;
    int m_date;
    int m_simSpeed;
    bool m_simSpeedChanged;
    bool m_paused;

private slots:
    void openSimuDialog();
    void changeSimSpeed(int newSpeed);
    void updateSimu();
    void stepSimu();
    void stopSimu();
    void resetAdvancedToDefault();
    void pauseSimu(bool);
};

#endif // MAINWINDOW_H
