#ifndef TEAM_H
#define TEAM_H

#include <vector>

#include "glm/vec3.hpp"

#include "coord.h"
#include "behavior.h"

#define NB_STARTING_FOOD 5
#define SPAWN_COOLDOWN 30

class Dude;

class Team
{
    glm::vec3 m_spawnColor;
    glm::vec3 m_dudeColor;
    int m_spawnCooldown;
    int m_foodQuantity;
    int m_dudesReady;
    BehaviorFunction m_behavior;
public:
    Team(const glm::vec3 &spawnColor, const glm::vec3 &dudeColor, BehaviorFunction _behavior);
    bool updateSpawn();
    void popDude();
    void addFood() {m_foodQuantity++; }
    void destroySpawn();
    void update(Dude*);
    glm::vec3 getSpawnColor() { return m_spawnColor; }
    glm::vec3 getDudeColor() { return m_dudeColor; }
};

#endif // TEAM_H
